#!/usr/bin/env fish

# Avoid running bearer-gen to make the initialization faster. 
mkdir -p /tmp/.antidote-complete-tmpdir ; and echo '#!/bin/bash' > /tmp/.antidote-complete-tmpdir/bearer-gen ; and chmod +x /tmp/.antidote-complete-tmpdir/bearer-gen
set -l commands_and_desc (env PATH="/tmp/.antidote-complete-tmpdir:$PATH" antidote-cis 2>&1 | grep "The '.*' subcommand" | sed "s/^[^']*'//g" | sed "s/' subcommand /|/g")

set -l __hostname (hostname)
set -l commands
set -l desc
for entry in $commands_and_desc
    set -a commands (echo $entry | sed 's/|.*$//g')
    set -a desc (echo $entry | sed 's/^.*|//g')
end

function __antidote_complete_list_workflows
    # TODO
    echo -e 'HelloWorkflow\nYourWorkflow'
end
function __antidote_complete_list_ver
    # TODO
    echo -e '1.0\n1.1'
end
function __antidote_complete_list_jobid
    echo -e '<JOB_ID HERE>\n2517645620722579999_df3a452e-d580-47c2-b96e-61f1671358c9'
end
function __antidote_complete_list_wfargs
    echo -e 'Alias=bensl\nParameterName1=Value1\n@RuntimeSettings2=Value2'
end

function __antidote_count_cmdline_args
    # This function counts arguments from a command line text. 
    # It take care of quotes and escaped space. 
    #
    # Note that, "antidote-cis push " counts as 3, because empty argument also counts! This is especially useful for completion. 
    set -l cleaned_cmdline (commandline -p | string replace --regex -a '\\\\.' '' | string replace --regex -a '"[^"]*"' '' | string replace --regex -a "'[^']*'" '' | string replace --regex -a ' +' ' ')
    count (echo $cleaned_cmdline | string split ' ')
end


complete -c antidote-cis --no-file
for i in (seq (count $commands))
    complete -c antidote-cis -n "not __fish_seen_subcommand_from $commands" -a $commands[$i] -d $desc[$i]
end

complete -c antidote-cis --force-files -n "__fish_seen_subcommand_from push; and test (__antidote_count_cmdline_args) = 3" -a "cis:// //$__hostname/"
complete -c antidote-cis -n "__fish_seen_subcommand_from push; and test (__antidote_count_cmdline_args) = 4" -a "(__antidote_complete_list_workflows)"
complete -c antidote-cis -n "__fish_seen_subcommand_from push; and test (__antidote_count_cmdline_args) = 5" -a "(__antidote_complete_list_ver)"

complete -c antidote-cis -n "__fish_seen_subcommand_from release setdef cloudrun listver; and test (__antidote_count_cmdline_args) = 3" -a "(__antidote_complete_list_workflows)"
complete -c antidote-cis -n "__fish_seen_subcommand_from release setdef cloudrun; and test (__antidote_count_cmdline_args) = 4" -a "(__antidote_complete_list_ver)"
complete -c antidote-cis -n "__fish_seen_subcommand_from cloudrun; and test (__antidote_count_cmdline_args) -gt 4" -a "(__antidote_complete_list_wfargs)"

complete -c antidote-cis --force-files -n "__fish_seen_subcommand_from jobtype-upload; and test (__antidote_count_cmdline_args) = 3"

complete -c antidote-cis -n "__fish_seen_subcommand_from jobstatus; and test (__antidote_count_cmdline_args) = 3" -a "(__antidote_complete_list_jobid)"


